'use strict';

var onPrint = function onPrint(type, match) {
	return function (window, cb) {
		var called = false,
		    query = void 0,
		    queryFn = void 0;

		var cleanup = function cleanup() {
			if (queryFn) query.removeListener(queryFn);
			window.removeEventListener(type + 'print', cleanup, false);
			if (!called) {
				called = true;
				cb();
			}
		};

		if (window.matchMedia) {
			queryFn = function queryFn(query) {
				if (query.matches === match) cleanup();
			};
			query = window.matchMedia('print');
			query.addListener(queryFn);
		}
		window.addEventListener(type + 'print', cleanup, false);
	};
};

module.exports = {
	before: onPrint('before', true),
	after: onPrint('after', false),
	onPrint: onPrint
};